package clockviewwrapper;

import com.arbelkilani.clock.Clock;

import com.arbelkilani.clock.enumeration.ClockValueDisposition;
import com.arbelkilani.clock.enumeration.ClockValueStep;
import com.arbelkilani.clock.enumeration.ClockValueType;
import com.arbelkilani.clock.model.ClockTheme;
import com.arbelkilani.clock.enumeration.ClockDegreeType;
import com.arbelkilani.clock.enumeration.ClockDegreeStep;

import android.content.Context;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.AbsObjectWrapper;

@ShortName("ClockViewBuilder")
@DependsOn(values={"com.android.support:support-v4"})
public class clockviewBuilderWrapper extends AbsObjectWrapper<ClockTheme.ClockThemeBuilder> {

	private BA ba;
	private String eventName;
    private ClockTheme.ClockThemeBuilder cv;
	
	public void Initialize(BA ba) {
		_initialize(ba, null);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass) {
		this.ba = ba;
		cv = new ClockTheme.ClockThemeBuilder();
        this.setObject(cv);
 	}
	
	public clockviewBuilderWrapper showCenter(boolean showCenter) {
		cv.showCenter(showCenter);
		return this;
	}
	
	public clockviewBuilderWrapper centerInnerColor(int innerColor) {
		cv.centerInnerColor(innerColor);
		return this;
	}	

	public clockviewBuilderWrapper centerOuterColor(int outerColor) {
		cv.centerOuterColor(outerColor);
		return this;
	}				
	
	 public clockviewBuilderWrapper showBorder(boolean showBorder) {
		cv.showBorder(showBorder);
		return this;
	}

	public clockviewBuilderWrapper borderColor(int bordercolor) {
		cv.borderColor(bordercolor);
		return this;
	}
	
	public clockviewBuilderWrapper showSecondsProgress(boolean showSecondsProgress) {
		cv.showSecondsProgress(showSecondsProgress);
		return this;
	}	

	public clockviewBuilderWrapper secondsProgressColor(int secondsprogressColor) {
		cv.SecondsProgressColor(secondsprogressColor);
		return this;
	}	

	public clockviewBuilderWrapper showSecondsNeedle(boolean showSecondsNeedle) {
		cv.showSecondsNeedle(showSecondsNeedle);
		return this;
	}		
	
	public clockviewBuilderWrapper showHoursValues(boolean showHoursValues) {
		cv.showHoursValues(showHoursValues);
		return this;
	}	

	public clockviewBuilderWrapper showDegrees(boolean showDegrees) {
		cv.showDegrees(showDegrees);
		return this;
	}		
	
	public clockviewBuilderWrapper setHoursNeedleColor(int hoursNeedleColor) {
		cv.setHoursNeedleColor(hoursNeedleColor);
		return this;
	}

	public clockviewBuilderWrapper setMinutesNeedleColor(int minutesNeedleColor) {
		cv.setMinutesNeedleColor(minutesNeedleColor);
		return this;
	}	

	public clockviewBuilderWrapper setDegreesColor(int degreesColor) {
		cv.setDegreesColor(degreesColor);
		return this;
	}	

	public clockviewBuilderWrapper showMinutesProgress(boolean showMinutesProgress) {
		cv.showMinutesProgress(showMinutesProgress);
		return this;
	}	

	public clockviewBuilderWrapper minutesProgressColor(int minutesProgressColor) {
		cv.minutesProgressColor(minutesProgressColor);
		return this;
	}	

	public clockviewBuilderWrapper setHoursValuesColor(int hoursValuesColor) {
		cv.setHoursValuesColor(hoursValuesColor);
		return this;
	}	

	public clockviewBuilderWrapper setSecondsNeedleColor(int secondsNeedleColor) {
		cv.setSecondsNeedleColor(secondsNeedleColor);
		return this;
	}	
	
	public clockviewBuilderWrapper setSecondsProgressFactor(float secondsProgressFactor) {
		if (secondsProgressFactor < 0.4f) secondsProgressFactor = 0.4f;
		if (secondsProgressFactor > 0.9f) secondsProgressFactor = 0.9f;
		cv.setSecondsProgressFactor(secondsProgressFactor);
		return this;
	}	

	public clockviewBuilderWrapper showMinutesValues(boolean showMinutesValues) {
		cv.showMinutesValues(showMinutesValues);
		return this;
	}	

	public clockviewBuilderWrapper setMinutesValuesFactor(float minutesValuesFactor) {
		cv.setMinutesValuesFactor(minutesValuesFactor);
		if (minutesValuesFactor < 0.2f) minutesValuesFactor = 0.2f;
		if (minutesValuesFactor > 0.5f) minutesValuesFactor = 0.5f;
		return this;
	}	

	public int DEGREE_TYPE_LINE = 0;
	public int DEGREE_TYPE_CIRCLE = 1;	
	public int DEGREE_TYPE_SQUARE = 2;
	public clockviewBuilderWrapper setClockDegreeType(int clockDegreesType) {
		if (clockDegreesType == 0) {
			cv.setClockDegreeType(ClockDegreeType.line);
		}
		if (clockDegreesType == 1) {
			cv.setClockDegreeType(ClockDegreeType.circle);
		}		
		if (clockDegreesType == 2) {
			cv.setClockDegreeType(ClockDegreeType.square);
		}	
		if (clockDegreesType < 0) {
			cv.setClockDegreeType(ClockDegreeType.line);
		}	
		if (clockDegreesType > 2) {
			cv.setClockDegreeType(ClockDegreeType.line);
		}	
		return this;			
		
	}	
	
	public int DEGREE_STEP_QUARTER = 90;
	public int DEGREE_STEP_FULL = 6;	
	public int DEGREE_STEP_TWELVE = 30;
	public clockviewBuilderWrapper setClockDegreeStep(int clockDegreeStep) {
		if (clockDegreeStep == 90) {
			cv.setClockDegreeStep(ClockDegreeStep.quarter);
		} else if (clockDegreeStep == 6){
			cv.setClockDegreeStep(ClockDegreeStep.full);
		} else if (clockDegreeStep == 30){    
			cv.setClockDegreeStep(ClockDegreeStep.twelve);		
		} else {
			cv.setClockDegreeStep(ClockDegreeStep.full);
		}
		return this;
	}	

	public int DISPOSITION_REGULAR = -1;
	public int DISPOSITION_ALTERNATE = 0;
	public clockviewBuilderWrapper setClockValueDisposition(int clockValueDisposition) {
		if (clockValueDisposition == -1) {
			cv.setClockValueDisposition(ClockValueDisposition.regular);
		} else {
			cv.setClockValueDisposition(ClockValueDisposition.alternate);
		}
		return this;
	}	
	
	public ClockTheme build() {
		return cv.build();
	} 		
 
} 
 
 