package clockviewwrapper;

import com.arbelkilani.clock.Clock;

import com.arbelkilani.clock.enumeration.ClockDegreeStep;
import com.arbelkilani.clock.enumeration.ClockDegreeType;
import com.arbelkilani.clock.enumeration.ClockValueDisposition;
import com.arbelkilani.clock.enumeration.ClockValueStep;
import com.arbelkilani.clock.enumeration.ClockValueType;
import com.arbelkilani.clock.model.ClockTheme;

import android.content.Context;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;

@ActivityObject
//@Events(values={"picture_changed(position As Int), scroll_stopped(), picture_touched(position As Int), picture_long_touched(position As Int)"})
@Author("Github: Belkilani Ahmed Radhouane, Wrapped by: Johan Schoeman")
@Version(1.01f)
@ShortName("ClockView")
@DependsOn(values={"com.android.support:support-v4"})
public class clockviewWrapper extends ViewWrapper<Clock> implements DesignerCustomView {

	private BA ba;
	private String eventName;
    private Clock cv;
	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new Clock(ba.context);
        this.setObject(cv);
 	}
	
    public void setShowCenter(boolean showCenter) {
        cv.setShowCenter(showCenter);
		cv.invalidate();
    }

    public void setCenterInnerColor(int centerInnerColor) {
        cv.setCenterInnerColor(centerInnerColor);
		cv.invalidate();
    }

    public void setCenterOuterColor(int centerOuterColor) {
        cv.setCenterOuterColor(centerOuterColor);
		cv.invalidate();
    }

    public void setShowHoursValues(boolean showHoursValues) {
        cv.setShowHoursValues(showHoursValues);
		cv.invalidate();
    }

    public void setShowBorder(boolean showBorder) {
        cv.setShowBorder(showBorder);
		cv.invalidate();
    }

    public void setBorderColor(int borderColor) {
        cv.setBorderColor(borderColor);
		cv.invalidate();
    }

    public void setShowHoursProgress(boolean showHoursProgress) {
        cv.setShowHoursProgress(showHoursProgress);
		cv.invalidate();
    }

    public void setHoursProgressColor(int hoursProgressColor) {
        cv.setHoursProgressColor(hoursProgressColor);
		cv.invalidate();
    }

    public void setShowMinutesProgress(boolean showMinutesProgress) {
        cv.setShowMinutesProgress(showMinutesProgress);
		cv.invalidate();
    }

    public void setMinutesProgressColor(int minutesProgressColor) {
        cv.setMinutesProgressColor(minutesProgressColor);
		cv.invalidate();
    }

    public void setMinutesProgressFactor(float minutesProgressFactor) {
        cv.setMinutesProgressFactor(minutesProgressFactor);
		cv.invalidate();
    }

    public void setShowSecondsProgress(boolean showSecondsProgress) {
        cv.setShowSecondsProgress(showSecondsProgress);
		cv.invalidate();
    }

    public void setSecondsProgressFactor(float secondsProgressFactor) {
        cv.setSecondsProgressFactor(secondsProgressFactor);
		cv.invalidate();
    }

    public void setSecondsProgressColor(int secondsProgressColor) {
        cv.setSecondsProgressColor(secondsProgressColor);
		cv.invalidate();
    }

    public void setShowSecondsNeedle(boolean showSecondsNeedle) {
        cv.setShowSecondsNeedle(showSecondsNeedle);
		cv.invalidate();
    }

    public void setSecondsNeedleColor(int secondsNeedleColor) {
        cv.setSecondsNeedleColor(secondsNeedleColor);
		cv.invalidate();
    }

    public void setHoursNeedleColor(int hoursNeedleColor) {
        cv.setHoursNeedleColor(hoursNeedleColor);
		cv.invalidate();
    }

    public void setMinutesNeedleColor(int minutesNeedleColor) {
        cv.setMinutesNeedleColor(minutesNeedleColor);
		cv.invalidate();
    }

    public void setHoursValuesColor(int hoursValuesColor) {
        cv.setHoursValuesColor(hoursValuesColor);
		cv.invalidate();
    }

    public void setClockType(int clockType) {
        cv.setClockType(clockType);
		cv.invalidate();
    }

    public void setShowDegrees(boolean showDegrees) {
        cv.setShowDegrees(showDegrees);
		cv.invalidate();
    }

	public int DEGREE_TYPE_LINE = 0;
	public int DEGREE_TYPE_CIRCLE = 1;	
	public int DEGREE_TYPE_SQUARE = 2;
    public void setClockDegreesType(int clockDegreesType) {
		if (clockDegreesType == 0) {
			cv.setClockDegreesType(ClockDegreeType.line);
        }
		if (clockDegreesType == 1) {
			cv.setClockDegreesType(ClockDegreeType.circle);
        }		
		if (clockDegreesType == 2) {
			cv.setClockDegreesType(ClockDegreeType.square);
        }	
        if (clockDegreesType < 0) {
			cv.setClockDegreesType(ClockDegreeType.line);
		}	
        if (clockDegreesType > 2) {
			cv.setClockDegreesType(ClockDegreeType.line);
		}	
        cv.invalidate();		
		
    }

	public int DEGREE_STEP_QUARTER = 90;
	public int DEGREE_STEP_FULL = 6;	
	public int DEGREE_STEP_TWELVE = 30;
    public void setClockDegreeStep(int clockDegreeStep) {
		if (clockDegreeStep == 90) {
			cv.setClockDegreeStep(ClockDegreeStep.quarter);
        } else if (clockDegreeStep == 6){
			cv.setClockDegreeStep(ClockDegreeStep.full);
		} else if (clockDegreeStep == 30){    
			cv.setClockDegreeStep(ClockDegreeStep.twelve);		
		} else {
			cv.setClockDegreeStep(ClockDegreeStep.full);
		}
    }

    public void setDegreesColor(int degreesColor) {
        cv.setDegreesColor(degreesColor);
		cv.invalidate();
    }

	public int DISPOSITION_REGULAR = -1;
	public int DISPOSITION_ALTERNATE = 0;
    public void setClockValueDisposition(int clockValueDisposition) {
        if (clockValueDisposition == -1) {
			cv.setClockValueDisposition(ClockValueDisposition.regular);
		} else {
			cv.setClockValueDisposition(ClockValueDisposition.alternate);
		}
		cv.invalidate();
    }

    public void setClockValueStep(int clockValueStep) {
        cv.setClockValueStep(clockValueStep);
		cv.invalidate();
    }

    public void setShowMinutesValues(boolean showMinutesValues) {
        cv.setShowMinutesValues(showMinutesValues);
		cv.invalidate();
    }

    public void setMinutesValuesFactor(float minutesValuesFactor) {
        cv.setMinutesValuesFactor(minutesValuesFactor);
		cv.invalidate();
    }

    public void setClockBackground(int clockBackground) {
        cv.setClockBackground(clockBackground);
		cv.invalidate();
    }
	
	public void setTheme(ClockTheme clockTheme) {
		cv.setTheme(clockTheme);
		cv.invalidate();
	}
	
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	
	
/*     Callback callback;
    public interface  Callback{
        void picture_changed();
		void scroll_stopped();
		void picture_touched();
		void picture_long_touched();
    }

    private void invokePictureChanged() {
        if(callback!=null){
            callback.picture_changed();
        }
    }
	
    private void invokeUserScrollStopped() {
        if(callback!=null){
            callback.scroll_stopped();
        }
    }	
	
    private void invokePictureTouched() {
        if(callback!=null){
            callback.picture_touched();
        }
    }	

    private void invokePictureLongTouched() {
        if(callback!=null){
            callback.picture_long_touched();
        }
    }			

    public void setCallback(Callback callback){
        this.callback = callback;
    }	
	
 */	
 
} 
 
 